import java.util.*;

public class DemoCollections {
    
    public static void stringListDemo() {
        List<String> names = new LinkedList<>();
        names.add("Jan");
        names.add("Karel");
        names.add("Petr");
        names.add("Libor");
        names.add(null);
        names.add("Radek");
        
        for (int i = 0; i < names.size(); i++) {
            //System.out.println(names.get(i));
            if ("Karel".equals(names.get(i))) {
                names.remove(i);
                i--;
            }
        }
        
        for (String n: names) {
            //System.out.println(n);
            if ("Karel".equals(n)) {
                names.remove(n);
            }
        }
        
        Iterator<String> it = names.iterator();
        while (it.hasNext()) {
            String n = it.next();
            if ("Karel".equals(n)) {
                it.remove();
            }
        }
        
        List<String> aux = new ArrayList<>();
        for (String n: names) {
            if ("Karel".equals(n)) {
                aux.add(n);
            }
        }
        names.removeAll(aux);
        
        while (names.contains("Karel")) {
            names.remove("Karel");
        }
        
        //System.out.println(names);
    }    
    
    
    public static void stringSetDemo() {
        Set<String> names = new HashSet<>();
        names.add("Jan");
        names.add("Karel");
        names.add("Petr");
        names.add("Libor");
        names.add(null);
        names.add("Radek");
        names.add("Petr");
        
        for (String n: names) {
            //System.out.println(n);
            if ("Karel".equals(n)) {
                names.remove(n);
            }
        }
        
        Iterator<String> it = names.iterator();
        while (it.hasNext()) {
            String n = it.next();
            if ("Karel".equals(n)) {
                it.remove();
            }
        }
        
        List<String> aux = new ArrayList<>();
        for (String n: names) {
            if ("Karel".equals(n)) {
                aux.add(n);
            }
        }
        names.removeAll(aux);
        
        if (names.contains("Karel")) {
            names.remove("Karel");
        }
        
        System.out.println(names);
    }
    
   
    public static void main(String[] args) {
        searchSetTest();
        searchListTest();
    }
    
    
    private static void searchSetTest() {
        Set<String> nameSet = new HashSet<String>();
        
        for(int i = 0; i < 30000; i++) {
            String s = "Retezec" + i;
            nameSet.add(s);
        }    
        
        long startTime = System.currentTimeMillis();
        int countInSet = 0;
        for(int i = 25000; i < 35000; i++) {
            String s = "Retezec" + i;
            if(nameSet.contains(s)) {
                countInSet++;
            }
        }    
        System.out.println("Count in set " + countInSet);
        long endTime = System.currentTimeMillis();
        
        System.out.println("Elapsed time set " + (endTime-startTime) + " ms.");
    }    
    
    private static void searchListTest() {
        List<String> nameList = new ArrayList<String>();
        
        for(int i = 0; i < 30000; i++) {
            String s = "Retezec" + i;
            nameList.add(s);
        }    
        
        long startTime = System.currentTimeMillis();
        int countInList = 0;
        for(int i = 25000; i < 35000; i++) {
            String s = "Retezec" + i;
            if(nameList.contains(s)) {
                countInList++;
            }
        }    
        System.out.println("Count in list " + countInList);
        long endTime = System.currentTimeMillis();
        
        System.out.println("Elapsed time list " + (endTime-startTime) + " ms.");
    } 
}
 
